
#include "simple.h"


CComModule _Module;


Simple::Simple() {
	// over here you can overrule the default display parameters
	// in m_config.parameters (orientation, swap settings, etc)
}

Simple::~Simple() {}

bool Simple::GameInit() { 
	TextureData = ::LoadImage(IDB_BITMAP);
	ShadingStep = 0.05f;
	Shading = 0.0f;
	return true; 
}

void Simple::GameLoop() {

    Surface *buffer = GetDisplay()->GetBackBuffer();
	if (!buffer) return;

	Pixel *bufptr = buffer->GetPixels();
	Pixel *texptr = TextureData->GetPixels();
	Pixel *sptr = texptr;
	Pixel *dptr = bufptr;

	for (int i=0; i<320; i++) {
		dptr = bufptr;
		sptr = texptr;
		for (int j=0; j<240; j++) {
			Pixel pix = *sptr++;
			int r = (int)(Shading*((pix & RED_MASK) >> RED_SHIFT));
			int g = (int)(Shading*((pix & GREEN_MASK) >> GREEN_SHIFT));
			int b = (int)(Shading*((pix & BLUE_MASK) >> BLUE_SHIFT));
			*dptr++ = (r << RED_SHIFT) + (g << GREEN_SHIFT) + (b << BLUE_SHIFT);
		}
		bufptr += buffer->GetPitch() >> 1;
		texptr += TextureData->GetPitch() >> 1;
	}
	
	Shading += ShadingStep;
	if (Shading >= 1.0f) 
		ShadingStep = -0.05f;
	else if (Shading <= 0.0f)
		ShadingStep = +0.05f;

	GetDisplay()->Swap();
}

void Simple::GameEnd() {
	// cleanup
}

void Simple::ButtonDown( int button ) {
	Game::ButtonDown(button); // shutdown
}

void Simple::ButtonUp( int button ) {}


int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE, LPTSTR, int )
{
    _Module.Init( 0, hInstance );
    
	Simple game;
	game.Run();
    
    return 0;
}
